// Nume: Stanca
// Prenume: Andrei
// Grupa 335CC

#include <avr/io.h>
#include <util/delay.h>
#include <stdio.h>
#define length 1
#define GREEN 1
#define RED 2
#define TIE 3

// Salvarea ledurilor intr-o structura

int L1[2] = {PA0, PA1}, 
	L2[2] = {PA2, PA3},
	L3[2] = {PA4, PA5},
	L4[2] = {PA6, PA7},
	L5[2] = {PC7, PC6},
	L6[2] = {PC5, PC4},
	L7[2] = {PC3, PC2},
	L8[2] = {PC1, PC0},
	L9[2] = {PB0, PB2};
int B1 = PB5,
	B2 = PD0,
	B3 = PB3,
	B4 = PD1,
	B5 = PD2,
	B6 = PD3,
	B7 = PD6,
	B8 = PD5,
	B9 = PD4;
int color = GREEN;
int set[9] = {0, 0, 0, 0, 0, 0, 0, 0, 0};


//Functie ce schimba culoarea

void switch_color()
{
	if (color == GREEN)
		color = RED;
	else
		color = GREEN;
}

//Functie de initializare

void initialize()
{
	DDRA |= (1 << L1[0]); DDRA |= (1 << L1[1]);
	DDRA |= (1 << L2[0]); DDRA |= (1 << L2[1]);
	DDRA |= (1 << L3[0]); DDRA |= (1 << L3[1]);
	DDRA |= (1 << L4[0]); DDRA |= (1 << L4[1]);
	DDRC |= (1 << L5[0]); DDRC |= (1 << L5[1]);
	DDRC |= (1 << L6[0]); DDRC |= (1 << L6[1]);
	DDRC |= (1 << L7[0]); DDRC |= (1 << L7[1]);
	DDRC |= (1 << L8[0]); DDRC |= (1 << L8[1]);
	DDRB |= (1 << L9[0]); DDRB |= (1 << L9[1]);
	
	DDRB &= ~(1 << B1); PORTB |= (1 << B1);
	DDRD &= ~(1 << B2); PORTD |= (1 << B2);
	DDRB &= ~(1 << B3); PORTB |= (1 << B3);
	DDRD &= ~(1 << B4); PORTD |= (1 << B4);
	DDRD &= ~(1 << B5); PORTD |= (1 << B5);
	DDRD &= ~(1 << B6); PORTD |= (1 << B6);
	DDRD &= ~(1 << B7); PORTD |= (1 << B7);
	DDRD &= ~(1 << B8); PORTD |= (1 << B8);
	DDRD &= ~(1 << B9); PORTD |= (1 << B9);
}

// Functie de joc 

void set_led(int led)
{
	if (set[led] == 0)
	{
		switch (led){
		case 1:
			PORTA &= ~(1 << L1[0]);
			PORTA &= ~(1 << L1[1]);
			if (color == GREEN)
				PORTA |= (1 << L1[0]);
			else
				PORTA |= (1 << L1[1]);
			break;
		case 2:
			PORTA &= ~(1 << L2[0]);
			PORTA &= ~(1 << L2[1]);
			if (color == GREEN)
				PORTA |= (1 << L2[0]);
			else
				PORTA |= (1 << L2[1]);
			break;
		case 3:
			PORTA &= ~(1 << L3[0]);
			PORTA &= ~(1 << L3[1]);
			if (color == GREEN)
				PORTA |= (1 << L3[0]);
			else
				PORTA |= (1 << L3[1]);
			break;
		case 4:
			PORTA &= ~(1 << L4[0]);
			PORTA &= ~(1 << L4[1]);
			if (color == GREEN)
				PORTA |= (1 << L4[0]);
			else
				PORTA |= (1 << L4[1]);
			break;
		case 5:
			PORTC &= ~(1 << L5[0]);
			PORTC &= ~(1 << L5[1]);
			if (color == GREEN)
				PORTC |= (1 << L5[0]);
			else
				PORTC |= (1 << L5[1]);
			break;
		case 6:
			PORTC &= ~(1 << L6[0]);
			PORTC &= ~(1 << L6[1]);
			if (color == GREEN)
				PORTC |= (1 << L6[0]);
			else
				PORTC |= (1 << L6[1]);
			break;
		case 7:
			PORTC &= ~(1 << L7[0]);
			PORTC &= ~(1 << L7[1]);
			if (color == GREEN)
				PORTC |= (1 << L7[0]);
			else
				PORTC |= (1 << L7[1]);
			break;
		case 8:
			PORTC &= ~(1 << L8[0]);
			PORTC &= ~(1 << L8[1]);
			if (color == GREEN)
				PORTC |= (1 << L8[0]);
			else
				PORTC |= (1 << L8[1]);
			break;
		case 9:
			PORTB &= ~(1 << L9[0]);
			PORTB &= ~(1 << L9[1]);
			if (color == GREEN)
				PORTB |= (1 << L9[0]);
			else
				PORTB |= (1 << L9[1]);
			break;
		}
		set[led] = color;
		switch_color();
	}
}

//Functie care decide cine este castigator

int winner()
{
	int i = 0, occ = 0, w = 0;
	
	for (i = 0; i < 2; i++)
		if (set[i*3 + 0] == set[i*3 + 1] && set[i*3 + 1] == set[i*3 + 2])
			w = set[i];
		if (set[i*3 + 0] == set[i*3 + 3] && set[i*3 + 3] == set[i*3 + 3])
			w = set[i];
			
	if (set[0] == set[4] && set[4] == set[8])
		w = set[0];
	if (set[6] == set[4] && set[4] == set[2])
		w = set[6];
		
	for ( i = 0; i < 9; i++)
		if (set[i] != 0)
			occ++;
	if (w == 0 && occ == 9)
		return TIE;
		
	return w;
}

//Functie care handle starea jocului odata ajuns la final

void finalize(int win)
{
	int i = 0;
	
	if (win == 0)
		return;
	PORTA &= ~(1 << L1[0]);
	PORTA &= ~(1 << L1[1]);
	PORTA &= ~(1 << L2[0]);
	PORTA &= ~(1 << L2[1]);
	PORTA &= ~(1 << L3[0]);
	PORTA &= ~(1 << L3[1]);
	PORTA &= ~(1 << L4[0]);
	PORTA &= ~(1 << L4[1]);
	PORTC &= ~(1 << L5[0]);
	PORTC &= ~(1 << L5[1]);
	PORTC &= ~(1 << L6[0]);
	PORTC &= ~(1 << L6[1]);
	PORTC &= ~(1 << L7[0]);
	PORTC &= ~(1 << L7[1]);
	PORTC &= ~(1 << L8[0]);
	PORTC &= ~(1 << L8[1]);
	PORTB &= ~(1 << L9[0]);
	PORTB &= ~(1 << L9[1]);
	if (win == GREEN)
	{
		PORTA |= (1 << L1[0]);
		PORTA |= (1 << L2[0]);
		PORTA |= (1 << L3[0]);
		PORTA |= (1 << L4[0]);
		PORTC |= (1 << L5[0]);
		PORTC |= (1 << L6[0]);
		PORTC |= (1 << L7[0]);
		PORTC |= (1 << L8[0]);
		PORTB |= (1 << L9[0]);
	}
	if (win == RED)
	{
		PORTA |= (1 << L1[1]);
		PORTA |= (1 << L2[1]);
		PORTA |= (1 << L3[1]);
		PORTA |= (1 << L4[1]);
		PORTC |= (1 << L5[1]);
		PORTC |= (1 << L6[1]);
		PORTC |= (1 << L7[1]);
		PORTC |= (1 << L8[1]);
		PORTB |= (1 << L9[1]);
	}
	if (win == TIE)
	{
		PORTA |= (1 << L1[1]);
		PORTA |= (1 << L2[1]);
		PORTA |= (1 << L3[1]);
		PORTA |= (1 << L4[0]);
		PORTC |= (1 << L5[0]);
		PORTC |= (1 << L6[0]);
		PORTC |= (1 << L7[1]);
		PORTC |= (1 << L8[1]);
		PORTB |= (1 << L9[1]);
	}
 	_delay_ms(20000);
	
	PORTA &= ~(1 << L1[0]);
	PORTA &= ~(1 << L1[1]);
	PORTA &= ~(1 << L2[0]);
	PORTA &= ~(1 << L2[1]);
	PORTA &= ~(1 << L3[0]);
	PORTA &= ~(1 << L3[1]);
	PORTA &= ~(1 << L4[0]);
	PORTA &= ~(1 << L4[1]);
	PORTC &= ~(1 << L5[0]);
	PORTC &= ~(1 << L5[1]);
	PORTC &= ~(1 << L6[0]);
	PORTC &= ~(1 << L6[1]);
	PORTC &= ~(1 << L7[0]);
	PORTC &= ~(1 << L7[1]);
	PORTC &= ~(1 << L8[0]);
	PORTC &= ~(1 << L8[1]);
	PORTB &= ~(1 << L9[0]);
	PORTB &= ~(1 << L9[1]);
	for (i = 0; i < 9; i++)
		set[i] = 0;

}


void play()
{
	while(1){
		if ((PINB & (1 << B1)) == 0) {
			set_led(1);
		}
		if ((PIND & (1 << B2)) == 0) {
			set_led(2);
		}
		if ((PINB & (1 << B3)) == 0) {
			set_led(3);
		}
		if ((PIND & (1 << B4)) == 0) {
			set_led(4);
		}
		if ((PIND & (1 << B5)) == 0) {
			set_led(5); 
		}
		if ((PIND & (1 << B6)) == 0) {
			set_led(6);
		}
		if ((PIND & (1 << B7)) == 0) {
			set_led(7);
		}
		if ((PIND & (1 << B8)) == 0) {
			set_led(8);
		}
		if ((PIND & (1 << B9)) == 0) {
			set_led(9);
		}
		finalize(winner());
			
	}
}


int main(void)
{
	initialize();
 	play();

    return 0;
}
